// ********************************************************************
// >>>>>>>>>>>>>>>>>>>>>>>>> COPYRIGHT NOTICE <<<<<<<<<<<<<<<<<<<<<<<<<
// ********************************************************************
// File name    : divide.v
// Module name  : divide
// Author       : STEP
// Description  : clock divider
// Web          : www.stepfpga.com
// 
// --------------------------------------------------------------------
// Code Revision History : 
// --------------------------------------------------------------------
// Version: |Mod. Date:   |Changes Made:
// V1.0     |2017/03/02   |Initial ver
// --------------------------------------------------------------------
// Module Function:ʱӷƵ
 
module clk_div (clk,rst_n,clkout);
 
        input 	clk,rst_n;                       //źţclkӵFPGAC1ţƵΪ12MHz
        output	clkout;                          //źţӵLED۲Ƶʱ
 
        //parameterverilogﳣ
	parameter	WIDTH	= 32;             //λֵΪ 2**WIDTH-1
	parameter	N	= 120;    //100K         //Ƶϵȷ N < 2**WIDTH-1
	//parameter	N	= 30;    //400K         //Ƶϵȷ N < 2**WIDTH-1

	reg 	[WIDTH-1:0]	cnt_p,cnt_n;     //cnt_pΪشʱļcnt_nΪ½شʱļ
	reg			clk_p,clk_n;     //clk_pΪشʱƵʱӣclk_nΪ½شʱƵʱ
 
	//شʱĿ
	always @ (posedge clk or negedge rst_n )         //posedgenegedgeverilogʾźغ½
                                                         //clkٻrst_n͵ʱִһalways
		begin
			if(!rst_n)
				cnt_p<=0;
			else if (cnt_p==(N-1))
				cnt_p<=0;
			else cnt_p<=cnt_p+1;             //һֱN-1ʱ㣬һģNļ
		end
 
         //شķƵʱ,NΪõʱռձȲ50%NΪżõʱռձΪ50%
         always @ (posedge clk or negedge rst_n)
		begin
			if(!rst_n)
				clk_p<=0;
			else if (cnt_p<(N>>1))          //N>>1ʾһλ൱ڳ2ȥ
				clk_p<=0;
			else 
				clk_p<=1;               //õķƵʱڱȸڶһclkʱ
		end
 
        //½شʱĿ        	
	always @ (negedge clk or negedge rst_n)
		begin
			if(!rst_n)
				cnt_n<=0;
			else if (cnt_n==(N-1))
				cnt_n<=0;
			else cnt_n<=cnt_n+1;
		end
 
        //½شķƵʱclk_pʱ
	always @ (negedge clk)
		begin
			if(!rst_n)
				clk_n<=0;
			else if (cnt_n<(N>>1))  
				clk_n<=0;
			else 
				clk_n<=1;                //õķƵʱڱȸڶһclkʱ
		end
 
        assign clkout = (N==1)?clk:(N[0])?(clk_p&clk_n):clk_p;      //жϱʽ
                                                                    //N=1ʱֱclk
                                                                    //NΪżҲNλΪ0N0=0clk_p
                                                                    //NΪҲNλΪ1N0=1clk_p&clk_nڶ
endmodule     